Index: /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java	(revision 8313)
@@ -563,516 +440,859 @@
     }
 
-    /** Method that is called whenever an element within a set is changed or modified. - needed for MSMListener
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
+
+    /** Called to inform this control panel that it has just gained focus as an effect of the user clicking on its tab.
      */
-    public void elementChanged(MSMEvent event) {}
-
-    /** Ensures a certain tree path is expanded, visible and selected within the collection tree.
-     * @param path The <strong>TreePath</strong> to make visible.
-     * @see org.greenstone.gatherer.gui.tree.DragTree
-     */
-    private void expandPath(TreePath path) {
-	collection_tree.expandPath(path);
-	collection_tree.setSelectionPath(path);
-    }
-    /** Called to inform this control panel that it has just gained focus as an effect of the user clicking on its tab.
-     * @see org.greenstone.gatherer.gui.tree.DragTree
-     */
-    public void gainFocus() {
-	// Use this opportunity to update the table model etc.
-	// Select the first file (if any)
-	if (collection_tree != null && collection_tree.getRowCount() > 0) {
-	    collection_tree.setImmediate(true);
-	    collection_tree.setSelectionRow(0);
-	    collection_tree.setImmediate(false);
-	}
-	else {
-	    // No selection. Reset other components
-	    valueChanged(new TreeSelectionEvent(this, null, false, null, null));
-	}
-
-	// Update the menubars idea of whats been selected
-	if (collection_tree != null) {
-	    if (collection_tree.isSelectionEmpty()) {
-		Gatherer.g_man.menu_bar.setMetaAuditSuffix(null);
-	    }
-	    else {
-		Gatherer.g_man.menu_bar.setMetaAuditSuffix(collection_tree.getSelectionDetails());
-	    }
-	}
-	// Update the meta-audit view to show the current selection, if any.
-	Gatherer.g_man.meta_audit.setRecords(records);
-    }
-
-    /** Retrieve the currently selected records.
-     * @return A <strong>FileNode[]</strong> containing the current, and up to date, selection.
-     */
-    public FileNode[] getSelectedNode() {
-	return records;
-    }
-
-    /** Called whenever the metadata value changes in some way, such as the addition of a new value. - needed for MSMListener
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     */
-    public void metadataChanged(MSMEvent event) {}
+    public void gainFocus()
+    {
+	// If there is nothing in the collection tree there is nothing to do
+	if (collection_tree == null || collection_tree.getRowCount() == 0) {
+	    System.err.println("No/empty collection tree... nothing to do.");
+	    return;
+	}
+
+	// Select the first node in the tree if nothing is already selected
+	if (collection_tree.getSelectionPaths() == null) {
+	    System.err.println("Nothing selected... selecting first tree node.");
+ 	    collection_tree.setImmediate(true);
+ 	    collection_tree.setSelectionRow(0);
+ 	    collection_tree.setImmediate(false);
+	}
+
+	// Force all of the controls to be updated
+	valueChanged(new TreeSelectionEvent(this, null, false, null, null));
+    }
+
 
     /** Called whenever the detail mode changes to ensure the filters are at an appropriate level (ie only editable by those that understand regular expression matching)
      * @param mode the mode level as an int
      */
-    public void modeChanged(int mode) {
+    public void modeChanged(int mode)
+    {
 	filter.setEditable(mode > Configuration.LIBRARIAN_MODE);
     }
 
-    /** Method that is called whenever the metadata set collection changes in some way, such as the addition of a new set or the merging of two sets. - needed for MSMListener
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
+
+    /** This method is called whenever the selection within the collection
+     * tree changes. This causes the table to be rebuilt with a new model.
      */
-    public void setChanged(MSMEvent event){
-	// call the collection tree value changed - we need to do the same stuff here
-	valueChanged((TreeSelectionEvent) null);
-    }
-
-    /** This method enables or diables the various controls based upon the state of the system. This method should be called after every change which could affect the GUI.
-     */
-    private void validateControls() {
-	validateControls(false);
-    }
-
-    private void validateControls(boolean update_card) {
-	validateMetadataTable();
-	// Validate card_layout_2
-	// We only ever change tools if the metadata table has finished building or is empty.
-	if (update_card) {
-	    if (selected_metadata == null && model.isBuildingComplete() && model.getRowCount() == 0) {
-		card_layout2.show(control_pane, TOOLS_OFF);
-	    }
-	    else {
-		card_layout2.show(control_pane, TOOLS_ON);
-	    }
-	}
-
-	// Validate the buttons in the lower pane
-	if (selected_metadata == null) {
-	    // Nothing selected
-	    return;
-	}
-
-	// Does the metadata element have no current value?
-	GValueNode value_node = selected_metadata.getValueNode();
-	if (value_node == null) {
-	    // Can only append if something has been entered
-	    add.setEnabled((tree.getSelectedValue().length() > 0));
-	    // Nothing to replace or remove
-	    update.setEnabled(false);
-	    remove.setEnabled(false);
-	}
-
+    public void valueChanged(TreeSelectionEvent event)
+    {
+	// Nothing selected in the collection tree
+	if (collection_tree.getSelectionCount() == 0) {
+	    file_nodes = null;
+
+	    // Update the label to show nothing is selected in the collection tree
+	    Dictionary.registerText(table_label, "MetaEdit.No_File");
+
+	    // Display the "no file selected" card
+	    metadata_value_table_card_layout.show(table_card_pane, TABLE_CARD_NO_FILES_SELECTED);
+	}
+
+	// Some files selected in the collection tree
 	else {
-	    // Check if the text in the value field is the same as the metadata value
-	    if (tree.getSelectedValue().equals(value_node.getFullPath(false))) {
-		// Can't replace
-		update.setEnabled(false);
-		// Adding, however, is dependant on whether the metadata is common or uncommon. If the later then you can append so as to make it common.
-		add.setEnabled(!model.isCommon(selected_metadata));
-	    }
-	    else {
-		// Can append or replace, if something has been entered
-		add.setEnabled((tree.getSelectedValue().length() > 0));
-		update.setEnabled((tree.getSelectedValue().length() > 0));
-	    }
-
-	    // Can only remove if the metadata is file level
-	    if (selected_metadata != null) {  // Shouldn't be necessary, but is
-		remove.setEnabled(selected_metadata.isFileLevel());
-	    }
-	}
-    }
-
-    /** Validate the metadata table area, and if no metadata is available display the no metadata panel. */
-    public void validateMetadataTable() {
-	// Validate card_layout
-	if (records == null) {
-	    card_layout.show(table_card_pane, CARD_ZERO);
-	} else if (model.getRowCount() == 0) {
-	    card_layout.show(table_card_pane, CARD_TWO);
-	} else {
-	    card_layout.show(table_card_pane, CARD_ONE);
-	}
-    }
-
-    /** Another in a long list of listeners, this one is called whenever the
-     * selection within the JTable changes. When it does we load the new data
-     * and set the selected_metadata if applicable (ie the metadata is non-
-     * empty).
-     * @param event The <strong>ListSelectionEvent</strong> which contains all the information about the event that has been fired.
-     * @see org.greenstone.gatherer.gui.table.GTableModel
-     * @see org.greenstone.gatherer.gui.EnrichPane.GValueTree
-     */
-    public void valueChanged(ListSelectionEvent event) {
-	// We only want to handle one event per selection, so wait for the value to stabilise
-	ListSelectionModel lsm = table.getSelectionModel();
-	if (lsm.getValueIsAdjusting() == false) {
-	    // We have a SINGLE_SELECTION model set so there is at most one
-	    // selection. Get the offending row.
-	    int selected = table.getSelectedRow();
-	    selected_metadata = model.getMetadataAtRow(selected);
-	    if (selected_metadata != null) { // Check something is selected.
-		tree.setSelectedMetadataElement(selected_metadata.getElement());
-		GValueNode value_node = selected_metadata.getValueNode();
-		if (value_node != null) {
-		    tree.setSelectedValue(value_node.getFullPath(true));
-		}
-		else {
-		    tree.setSelectedValue("");
-		}
-	    }
-	    validateControls(true);
-	}
-    }
-
-    /** Called whenever the value tree of an metadata element changes in some way, such as the addition of a new value. - needed for MSMListener
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     */
-    public void valueChanged(MSMEvent event) {}
-
-    /** This method is called whenever the selection within the collection
-     * tree changes. This causes the table to be rebuilt with a new model
-     * @param event A <strong>TreeSelectionEvent</strong> containing information about the event.
-     * @see org.greenstone.gatherer.Gatherer
-     * @see org.greenstone.gatherer.file.FileNode
-     * @see org.greenstone.gatherer.gui.GUIManager
-     * @see org.greenstone.gatherer.gui.MenuBar
-     * @see org.greenstone.gatherer.gui.table.GTableModel
-     * @see org.greenstone.gatherer.msm.MetadataSetManager
-     * @see org.greenstone.gatherer.gui.tree.DragTree
-     * @see org.greenstone.gatherer.util.ArrayTools
-     */
-    public void valueChanged(TreeSelectionEvent event) {
-	///ystem.err.println("\n(MEP) valueChanged(TreeSelectionEvent)...");
-
-	// Don't bother if this isn't the selected view
-	// if (Gatherer.g_man.getSelectedView() != this) {
-	//     return;
-	// }
-
-	if (collection_tree.getSelectionCount() > 0) {
-	    records = null;
 	    TreePath paths[] = collection_tree.getSelectionPaths();
-	    records = new FileNode[paths.length];
+	    file_nodes = new FileNode[paths.length];
 	    for (int i = 0; i < paths.length; i++) {
-		FileNode record = (FileNode) paths[i].getLastPathComponent();
-		records[i] = record;
-	    }
-
-	    // Remember the previous selection so we can select it again later
-	    Metadata previous_selection = selected_metadata;
-
+		file_nodes[i] = (FileNode) paths[i].getLastPathComponent();
+	    }
+
+	    // Update the label to show what is selected in the collection tree
 	    table_label.setText(collection_tree.getSelectionDetails());
-
-	    // Remove old model from msm
-	    Gatherer.c_man.getCollection().msm.removeMSMListener(model);
-	    // Create new model
-	    model = new GTableModel(table, records);
-	    table.setModel(model);
-
-	    // Select the closest piece of metadata in the new file
-	    model.selectClosestMetadataWhenBuildingComplete(previous_selection);
-	}
-	else {
-	    records = null;
-	    Dictionary.registerText(table_label, "MetaEdit.No_File");
-
-	    // Remove old model from msm
-	    if (Gatherer.c_man.ready()) {
-		Gatherer.c_man.getCollection().msm.removeMSMListener(model);
-	    }
-	    // Create new model
-	    model = new GTableModel(table);
-	    table.setModel(model);
-	}
-
-	if (table != null) {
-	    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
-	    Dimension table_size = table.getPreferredSize();
-	    TableColumnModel column_model = table.getColumnModel();
+	}
+
+	// Update the metadata value table (and consequently, the metadata value tree)
+	metadata_value_table.rebuild();
+
+// 	// Update the meta-audit view to show the current selection, if any.
+// 	Gatherer.g_man.meta_audit.setRecords(file_nodes);
+    }
+
+
+    private class AppendMetadataTask
+	extends Thread
+    {
+	private MetadataValue metadata_value = null;
+
+	private AppendMetadataTask(MetadataValue metadata_value)
+	{
+	    this.metadata_value = metadata_value;
+	}
+
+	public void run()
+	{
+	    if (file_nodes == null || metadata_value == null) {
+		return;
+	    }
+
+	    // If we're adding metadata to folders display the warning
+	    if (!file_nodes[0].isLeaf()) {
+		WarningDialog dialog = new WarningDialog("warning.DirectoryLevelMetadata", true);
+		int dialog_result = dialog.display();
+		dialog.dispose();
+
+		if (dialog_result != JOptionPane.OK_OPTION) {
+		    return;
+		}
+	    }
+
+	    // Edit metadata.xml files to add the metadata
+	    MetadataXMLFileManager.addMetadata(file_nodes, metadata_value);
+
+	    // Update the metadata value table and tree
+	    metadata_edit_event = true;
+	    metadata_value_table.rebuild();
+	    metadata_edit_event = false;
+	}
+    }
+
+
+    private class UpdateMetadataTask
+	extends Thread
+    {
+	private MetadataValue metadata_value = null;
+
+	private UpdateMetadataTask(MetadataValue metadata_value)
+	{
+	    this.metadata_value = metadata_value;
+	}
+
+	public void run()
+	{
+	    MetadataValueTableEntry selected_metadata_value_table_entry = metadata_value_table.getSelectedMetadataValueTableEntry();
+	    if (selected_metadata_value_table_entry == null || file_nodes == null || metadata_value == null) {
+		return;
+	    }
+
+	    // Edit metadata.xml files to replace the metadata
+	    MetadataXMLFileManager.removeMetadata(file_nodes, selected_metadata_value_table_entry);
+	    MetadataXMLFileManager.addMetadata(file_nodes, metadata_value);
+
+	    // Update the metadata value table and tree
+	    metadata_edit_event = true;
+	    metadata_value_table.rebuild();
+	    metadata_edit_event = false;
+	}
+    }
+
+
+    private class RemoveMetadataTask
+	extends Thread
+    {
+	public void run()
+	{
+	    MetadataValueTableEntry selected_metadata_value_table_entry = metadata_value_table.getSelectedMetadataValueTableEntry();
+	    if (selected_metadata_value_table_entry == null || file_nodes == null) {
+		return;
+	    }
+
+	    // Edit metadata.xml files to remove the metadata
+	    MetadataXMLFileManager.removeMetadata(file_nodes, selected_metadata_value_table_entry);
+
+	    // Update the metadata value table and tree
+	    metadata_edit_event = true;
+	    metadata_value_table.rebuild();
+	    metadata_edit_event = false;
+	}
+    }
+
+
+    private class MetadataValueTable
+	extends JTable
+    {
+	private MetadataValueTableModel metadata_value_table_model = null;
+	/** The currently selected metadata value table entry */
+	private MetadataValueTableEntry selected_metadata_value_table_entry = null;
+
+
+	public MetadataValueTable()
+	{
+	    metadata_value_table_model = new MetadataValueTableModel();
+	    setModel(metadata_value_table_model);
+
+	    // We allow only one row to be selected at a time
+	    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
+	    getSelectionModel().addListSelectionListener(new MetadataValueTableListSelectionListener());
+
+	    // The default JTable doesn't quite have the desired properties - when a
+	    // table cell is clicked on, the table is scrolled so the cell is as
+	    // visible as possible. This means that the left-most cells can become
+	    // hidden. To fix this, the MouseInputHandler in BasicTableUI is removed
+	    // as a MouseListener on the table, and a very slightly altered copy is
+	    // added in its place (TableMouseInputHandler).
+	    MouseListener[] mls = getMouseListeners();
+	    for (int i = 0; i < mls.length; i++) {
+		// Remove the instances of MouseInputHandler
+		if (mls[i].toString().startsWith("javax.swing.plaf.basic.BasicTableUI$MouseInputHandler@")) {
+		    removeMouseListener(mls[i]);
+		}
+	    }
+	    // Add the slightly-altered mouse listener
+	    addMouseListener(new TableMouseInputHandler());
+
+	    // We also have to ensure that the table column header hasn't gone on a severe Jenny Craig binge and has somehow lost 7/8th of its component size
+	    JTableHeader table_header = getTableHeader();
+	    Dimension table_header_preferred_size = table_header.getPreferredSize();
+	    if (table_header_preferred_size.height < MINIMUM_TABLE_HEADER_SIZE) {
+		table_header_preferred_size.setSize(table_header_preferred_size.width, MINIMUM_TABLE_HEADER_SIZE);
+		table_header.setPreferredSize(table_header_preferred_size);
+	    }
+
+	    // Set the table columns as we want them
+	    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
+	    Dimension table_size = getPreferredSize();
+	    TableColumnModel column_model = getColumnModel();
 
 	    TableColumn inherited_column = column_model.getColumn(0);
 	    inherited_column.setPreferredWidth(20);
-	    inherited_column.setCellRenderer(new TableCellRenderer(model));
+	    inherited_column.setCellRenderer(new MetadataValueTableCellRenderer(metadata_value_table_model));
 
 	    TableColumn element_column = column_model.getColumn(1);
 	    element_column.setPreferredWidth((TABLE_SIZE.width / 4) - 15);
-	    element_column.setCellRenderer(new TableCellRenderer(model));
+	    element_column.setCellRenderer(new MetadataValueTableCellRenderer(metadata_value_table_model));
 
 	    TableColumn value_column = column_model.getColumn(2);
 	    value_column.setPreferredWidth(((3 * TABLE_SIZE.width) / 4) - 30);
-	    value_column.setCellRenderer(new TableCellRenderer(model));
-	}
-	table.doLayout();
-	validateControls();
-    }
-
-
-    /** A direct copy of javax.swing.plaf.basic.BasicTableUI$MouseInputHandler, except for one change in adjustFocusAndSelection(). The purpose of this change is to always keep the left-most cells of the table row selected visible. */
-    private class TableMouseInputHandler implements MouseInputListener
+	    value_column.setCellRenderer(new MetadataValueTableCellRenderer(metadata_value_table_model));
+	}
+
+
+ 	public MetadataElement getSelectedMetadataElement()
+ 	{
+ 	    return selected_metadata_value_table_entry.getMetadataElement();
+ 	}
+
+
+	public MetadataValueTableEntry getSelectedMetadataValueTableEntry()
+	{
+	    return selected_metadata_value_table_entry;
+	}
+
+
+	public boolean isSelectedMetadataValueTableEntryCommon()
+	{
+	    return metadata_value_table_model.isCommon(selected_metadata_value_table_entry);
+	}
+
+
+	public void rebuild()
+	{
+	    // Remember the current metadata element selection so we can select it again later
+	    MetadataValueTableEntry previously_selected_metadata_value_table_entry = selected_metadata_value_table_entry;
+
+	    // We don't want a lot of ListSelectionEvents while the table is rebuilding
+	    clearSelection();
+
+	    // Rebuild the metadata value table model
+	    metadata_value_table_model.rebuild(file_nodes);
+
+	    // If the metadata value table is empty there isn't much to do
+	    if (metadata_value_table_model.getRowCount() == 0) {
+		// ...except display the "no metadata available" card, unless no files are selected
+		if (file_nodes != null) {
+		    metadata_value_table_card_layout.show(table_card_pane, TABLE_CARD_NO_METADATA_AVAILABLE);
+		}
+		return;
+	    }
+
+	    // Display the card with the metadata value table
+	    metadata_value_table_card_layout.show(table_card_pane, TABLE_CARD);
+
+	    // If there was no previous selection then we're done
+	    if (previously_selected_metadata_value_table_entry == null) {
+		return;
+	    }
+
+ 	    // Look for an exact match
+ 	    for (int i = 0; i < metadata_value_table_model.getRowCount(); i++) {
+ 		MetadataValueTableEntry metadata_value_table_entry = metadata_value_table_model.getMetadataValueTableEntry(i);
+ 		int c = metadata_value_table_entry.compareTo(previously_selected_metadata_value_table_entry);
+
+ 		if (c == 0) {
+		    // Select this row and we're done
+		    addRowSelectionInterval(i, i);
+ 		    return;
+ 		}
+
+ 		if (c < 0) {
+ 		    // Not in the list
+ 		    break;
+ 		}
+ 	    }
+
+ 	    // Select the first entry with the same metadata element
+ 	    MetadataElement previously_selected_metadata_element = previously_selected_metadata_value_table_entry.getMetadataElement();
+ 	    for (int i = 0; i < metadata_value_table_model.getRowCount(); i++) {
+ 		MetadataElement metadata_element = metadata_value_table_model.getMetadataValueTableEntry(i).getMetadataElement();
+ 		if (metadata_element.equals(previously_selected_metadata_element)) {
+		    // Select this row and we're done
+		    addRowSelectionInterval(i, i);
+ 		    return;
+ 		}
+ 	    }
+
+ 	    // All else has failed, so just select the first row in the table
+	    addRowSelectionInterval(0, 0);
+	}
+
+
+	private class MetadataValueTableListSelectionListener
+	    implements ListSelectionListener
+	{
+	    public void valueChanged(ListSelectionEvent event)
+	    {
+		// We only want to handle one event per selection, so wait for the value to stabilise
+		if (getSelectionModel().getValueIsAdjusting() == true) {
+		    return;
+		}
+
+		// System.err.println("In MetadataValueTableListSelectionListener.valueChanged()...");
+
+ 		selected_metadata_value_table_entry = null;
+ 		MetadataElement selected_metadata_element = null;
+ 		String selected_metadata_value = "";
+
+ 		// We have a SINGLE_SELECTION model set so there is at most one selection
+ 		int selected_row = getSelectedRow();
+ 		if (selected_row >= 0) {
+ 		    selected_metadata_value_table_entry = metadata_value_table_model.getMetadataValueTableEntry(selected_row);
+ 		    selected_metadata_element = selected_metadata_value_table_entry.getMetadataElement();
+ 		    MetadataValueTreeNode metadata_value_tree_node = selected_metadata_value_table_entry.getMetadataValueTreeNode();
+ 		    if (metadata_value_tree_node != null) {
+ 			selected_metadata_value = metadata_value_tree_node.getFullValue();
+ 		    }
+ 		}
+
+		// Update the metadata value tree
+		metadata_value_tree.rebuild(selected_metadata_element, selected_metadata_value);
+	    }
+	}
+
+
+	/** A direct copy of javax.swing.plaf.basic.BasicTableUI$MouseInputHandler, except for one change in adjustFocusAndSelection(). The purpose of this change is to always keep the left-most cells of the table row selected visible. */
+	private class TableMouseInputHandler implements MouseInputListener
+	{
+	    // Component receiving mouse events during editing.
+	    // May not be editorComponent.
+	    private Component dispatchComponent;
+	    private boolean selectedOnPress;
+
+	    //  The Table's mouse listener methods.
+
+	    public void mouseClicked(MouseEvent e) {}
+
+	    private void setDispatchComponent(MouseEvent e) {
+		Component editorComponent = getEditorComponent();
+		Point p = e.getPoint();
+		Point p2 = SwingUtilities.convertPoint(metadata_value_table, p, editorComponent);
+		dispatchComponent = SwingUtilities.getDeepestComponentAt(editorComponent,
+									 p2.x, p2.y);
+	    }
+
+	    private boolean repostEvent(MouseEvent e) {
+		// Check for isEditing() in case another event has
+		// caused the editor to be removed. See bug #4306499.
+		if (dispatchComponent == null || !isEditing()) {
+		    return false;
+		}
+		MouseEvent e2 = SwingUtilities.convertMouseEvent(metadata_value_table, e, dispatchComponent);
+		dispatchComponent.dispatchEvent(e2);
+		return true;
+	    }
+
+	    private void setValueIsAdjusting(boolean flag) {
+		getSelectionModel().setValueIsAdjusting(flag);
+		getColumnModel().getSelectionModel().setValueIsAdjusting(flag);
+	    }
+
+	    private boolean shouldIgnore(MouseEvent e) {
+		return e.isConsumed() || (!(SwingUtilities.isLeftMouseButton(e) && isEnabled()));
+	    }
+
+	    public void mousePressed(MouseEvent e) {
+		if (e.isConsumed()) {
+		    selectedOnPress = false;
+		    return;
+		}
+		selectedOnPress = true;
+		adjustFocusAndSelection(e);
+	    }
+
+	    void adjustFocusAndSelection(MouseEvent e) {
+		if (shouldIgnore(e)) {
+		    return;
+		}
+
+		Point p = e.getPoint();
+		int row = rowAtPoint(p);
+		int column = columnAtPoint(p);
+		// The autoscroller can generate drag events outside the Table's range.
+		if ((column == -1) || (row == -1)) {
+		    return;
+		}
+
+		if (editCellAt(row, column, e)) {
+		    setDispatchComponent(e);
+		    repostEvent(e);
+		}
+		else if (isRequestFocusEnabled()) {
+		    requestFocus();
+		}
+
+		CellEditor editor = getCellEditor();
+		if (editor == null || editor.shouldSelectCell(e)) {
+		    boolean adjusting = (e.getID() == MouseEvent.MOUSE_PRESSED) ? true : false;
+		    setValueIsAdjusting(adjusting);
+
+		    // Special code for clicking the first column (folder-level metadata)
+		    if (column == 0) {
+			selected_metadata_value_table_entry = metadata_value_table_model.getMetadataValueTableEntry(row);
+
+			// If this metadata is inherited, switch to the folder it came from
+			if (selected_metadata_value_table_entry.isInheritedMetadata()) {
+			    File folder_metadata_inherited_from = selected_metadata_value_table_entry.getFolderMetadataInheritedFrom();
+			    if (folder_metadata_inherited_from != null) {
+				collection_tree.setSelection(folder_metadata_inherited_from);
+			    }
+			}
+
+			changeSelection(row, 0, e.isControlDown(), e.isShiftDown());
+		    }
+		    else {
+			changeSelection(row, 1, e.isControlDown(), e.isShiftDown());
+		    }
+		}
+	    }
+
+	    public void mouseReleased(MouseEvent e) {
+		if (selectedOnPress) {
+		    if (shouldIgnore(e)) {
+			return;
+		    }
+
+		    repostEvent(e);
+		    dispatchComponent = null;
+		    setValueIsAdjusting(false);
+		} else {
+		    adjustFocusAndSelection(e);
+		}
+	    }
+
+
+	    public void mouseEntered(MouseEvent e) {}
+
+	    public void mouseExited(MouseEvent e) {}
+
+	    //  The Table's mouse motion listener methods.
+
+	    public void mouseMoved(MouseEvent e) {}
+
+	    public void mouseDragged(MouseEvent e) {
+		if (shouldIgnore(e)) {
+		    return;
+		}
+
+		repostEvent(e);
+
+		CellEditor editor = getCellEditor();
+		if (editor == null || editor.shouldSelectCell(e)) {
+		    Point p = e.getPoint();
+		    int row = rowAtPoint(p);
+		    int column = columnAtPoint(p);
+		    // The autoscroller can generate drag events outside the Table's range.
+		    if ((column == -1) || (row == -1)) {
+			return;
+		    }
+		    changeSelection(row, column, false, true);
+		}
+	    }
+	}
+    }
+
+
+    /**
+     * This class is a little bit complex, a little bit subtle, and a little bit odd.
+     * The strange interaction model is due to the fact that it is very tightly
+     * coupled to the EnrichPane.
+     *
+     * The interaction is complex because there are three separate controls that the
+     * user may interact with, each of which can affect the other two. The three
+     * controls are:
+     *   - The "assigned metadata" table, at the top right of the meta edit pane.
+     *   - The "metadata value" text field, where users can type in new values.
+     *   - The "metadata value tree", which shows other values that have been
+     *     assigned to the selected metadata element.
+     *
+     * The interactions are:
+     *   - The "assigned metadata" table
+     *     Users may select one (and only one) row in this table. Selecting a row
+     *     chooses one metadata element. The text field will be set to the current
+     *     value of the metadata element. This value will also be selected in the
+     *     metadata value tree.
+     *
+     *   - The "metadata value" text field
+     *     If the value the user has typed in this is a prefix of an entry in the
+     *     value tree, this value will be selected in the value tree. In this case,
+     *     pressing "Tab" will complete the value (ie. make the value in the text
+     *     field the same as the value in the tree). This is to allow users to
+     *     quickly and easily assign existing metadata values to new documents.
+     *
+     *   - The "metadata value tree"
+     *     Selecting a value in the tree will set the text field to this value.
+     */
+    private class MetadataValueTree
+	extends JPanel
+	implements TreeSelectionListener
     {
-        // Component receiving mouse events during editing.
-        // May not be editorComponent.
-        private Component dispatchComponent;
-	private boolean selectedOnPress;
-
-	//  The Table's mouse listener methods.
-
-        public void mouseClicked(MouseEvent e) {}
-
-        private void setDispatchComponent(MouseEvent e) {
-            Component editorComponent = table.getEditorComponent();
-            Point p = e.getPoint();
-            Point p2 = SwingUtilities.convertPoint(table, p, editorComponent);
-            dispatchComponent = SwingUtilities.getDeepestComponentAt(editorComponent,
-								     p2.x, p2.y);
-        }
-
-        private boolean repostEvent(MouseEvent e) {
-	    // Check for isEditing() in case another event has
-	    // caused the editor to be removed. See bug #4306499.
-            if (dispatchComponent == null || !table.isEditing()) {
-                return false;
-            }
-            MouseEvent e2 = SwingUtilities.convertMouseEvent(table, e, dispatchComponent);
-            dispatchComponent.dispatchEvent(e2);
-            return true;
-        }
-
-        private void setValueIsAdjusting(boolean flag) {
-            table.getSelectionModel().setValueIsAdjusting(flag);
-            table.getColumnModel().getSelectionModel().setValueIsAdjusting(flag);
-        }
-
-	private boolean shouldIgnore(MouseEvent e) {
-	    return e.isConsumed() || (!(SwingUtilities.isLeftMouseButton(e) && table.isEnabled()));
-	}
-
-        public void mousePressed(MouseEvent e) {
-	    if (e.isConsumed()) {
-		selectedOnPress = false;
-		return;
-	    }
-	    selectedOnPress = true;
-	    adjustFocusAndSelection(e);
-	}
-
-	void adjustFocusAndSelection(MouseEvent e) {
-	    if (shouldIgnore(e)) {
-	        return;
-	    }
-
-            Point p = e.getPoint();
-            int row = table.rowAtPoint(p);
-            int column = table.columnAtPoint(p);
-	    // The autoscroller can generate drag events outside the Table's range.
-            if ((column == -1) || (row == -1)) {
-                return;
-            }
-
-            if (table.editCellAt(row, column, e)) {
-                setDispatchComponent(e);
-                repostEvent(e);
-            }
-	    else if (table.isRequestFocusEnabled()) {
-                table.requestFocus();
-	    }
-
-            CellEditor editor = table.getCellEditor();
-            if (editor == null || editor.shouldSelectCell(e)) {
-		boolean adjusting = (e.getID() == MouseEvent.MOUSE_PRESSED) ? true : false;
-                setValueIsAdjusting(adjusting);
-
-		// Special code for clicking the first column (folder-level metadata)
-		if (column == 0) {
-		    selected_metadata = model.getMetadataAtRow(row);
-
-		    // If this metadata is inherited, switch to the folder it came from
-		    if (!selected_metadata.isFileLevel()) {
-			File folder_inherited_from = selected_metadata.getFile();
-			if (folder_inherited_from != null) {
-			    collection_tree.setSelection(folder_inherited_from);
+	private boolean ignore_tree_selection_event = false;
+	private boolean manual_text_edit_event = false;
+	private CardLayout card_layout;
+	private String card_showing = null;
+	/** The metadata element that is currently selected. */
+	private MetadataElement selected_metadata_element = null;
+	private JTextArea extracted_message;
+	private JTextField value;
+	private JTree tree;
+
+	static final private String NONE = "None";
+	static final private String TREE = "Tree";
+
+
+	public MetadataValueTree(int width, int height)
+	{
+	    super();
+
+	    setFont(Configuration.getFont("general.font", false));
+	    setPreferredSize(new Dimension(width, height));
+
+	    JPanel metadata_pane = new JPanel();
+
+	    JPanel value_pane = new JPanel();
+	    JLabel value_label = new JLabel();
+	    Dictionary.registerText(value_label, "MetaEdit.Value");
+
+	    JPanel value_field_pane = new JPanel();
+	    value = new JTextField();
+	    value.setBackground(Configuration.getColor("coloring.editable_background", false));
+	    value.setForeground(Configuration.getColor("coloring.editable_foreground", false));
+	    value.setPreferredSize(new Dimension(413, 24));
+	    value.getDocument().addDocumentListener(new DocumentListenerImpl());
+	    value.addKeyListener(new MetadataFieldListener());
+	    value.setFocusTraversalKeysEnabled(false);
+	    Dictionary.setTooltip(value, "MetaEdit.Value_Field_Tooltip");
+
+	    JPanel button_pane = new JPanel();
+
+	    JPanel tree_pane = new JPanel();
+	    JLabel tree_label = new JLabel();
+	    Dictionary.registerText(tree_label, "MetaEdit.Tree");
+
+	    tree = new JTree();
+	    tree.addTreeSelectionListener(this);
+	    tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
+	    tree.setRootVisible(false);
+	    tree.putClientProperty("JTree.lineStyle", "Angled");
+
+	    JPanel extracted_pane = new JPanel();
+	    JPanel extracted_header_pane = new JPanel();
+	    extracted_message = new JTextArea("");
+	    extracted_message.setEditable(false);
+	    extracted_message.setLineWrap(true);
+	    extracted_message.setOpaque(false);
+	    extracted_message.setWrapStyleWord(true);
+
+	    card_layout = new CardLayout();
+
+	    // Layout
+	    value_field_pane.setBorder(BorderFactory.createEmptyBorder(0,5,0,5));
+	    value_field_pane.setLayout(new BorderLayout(0, 0));
+	    value_field_pane.add(value, BorderLayout.CENTER);
+
+	    button_pane.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
+	    button_pane.setLayout(new GridLayout());
+	    button_pane.add(add);
+	    button_pane.add(update);
+	    button_pane.add(remove);
+
+	    value_pane.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
+	    value_pane.setLayout(new BorderLayout());
+	    value_pane.add(value_label, BorderLayout.WEST);
+	    value_pane.add(value_field_pane, BorderLayout.CENTER);
+	    value_pane.add(expand, BorderLayout.EAST);
+	    value_pane.add(button_pane, BorderLayout.SOUTH);
+
+	    tree_pane.setLayout(new BorderLayout());
+	    tree_pane.add(tree_label, BorderLayout.NORTH);
+	    tree_pane.add(new JScrollPane(tree), BorderLayout.CENTER);
+
+	    metadata_pane.setLayout(new BorderLayout());
+	    metadata_pane.add(value_pane, BorderLayout.NORTH);
+	    metadata_pane.add(tree_pane, BorderLayout.CENTER);
+
+	    extracted_header_pane.setLayout(new BorderLayout());
+	    extracted_header_pane.add(expand_for_extracted, BorderLayout.EAST);
+
+	    extracted_pane.setBorder(BorderFactory.createEmptyBorder(0,10,25,0));
+	    extracted_pane.setLayout(new BorderLayout());
+	    extracted_pane.add(extracted_header_pane, BorderLayout.NORTH);
+	    extracted_pane.add(extracted_message, BorderLayout.CENTER);
+
+	    this.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
+	    this.setLayout(card_layout);
+	    this.add(metadata_pane, TREE);
+	    this.add(extracted_pane, NONE);
+	    card_showing = TREE;
+	}
+
+
+	/** Returns a TreePath for the node most closely matching the metadata value. */
+	private TreePath getClosestPath(String val)
+	{
+	    // Start at the root of the tree
+	    MetadataValueTreeNode tree_node = (MetadataValueTreeNode) tree.getModel().getRoot();
+
+	    // Separate hierarchical values
+	    PatternTokenizer tokenizer = new PatternTokenizer(val, MetadataValueTreeNode.METADATA_VALUE_TREE_NODE_HIERARCHY_TOKEN);
+	    while (tokenizer.hasMoreTokens()) {
+		String token = tokenizer.nextToken();
+
+		// All components except the last must match exactly
+		if (tokenizer.hasMoreTokens()) {
+		    for (int i = 0; i < tree_node.getChildCount(); i++) {
+			MetadataValueTreeNode child_node = (MetadataValueTreeNode) tree_node.getChildAt(i);
+			if (child_node.getValue().equals(token)) {
+			    // The matching node has been found, so move onto the next token
+			    tree_node = child_node;
+			    break;
 			}
 		    }
-
-		    table.changeSelection(row, 0, e.isControlDown(), e.isShiftDown());
-		}
+		}
+
+		// The last component may match partially
 		else {
-		    table.changeSelection(row, 1, e.isControlDown(), e.isShiftDown());
-		}
-	    }
-        }
-
-        public void mouseReleased(MouseEvent e) {
-	    if (selectedOnPress) {
-		if (shouldIgnore(e)) {
+		    for (int i = 0; i < tree_node.getChildCount(); i++) {
+			MetadataValueTreeNode child_node = (MetadataValueTreeNode) tree_node.getChildAt(i);
+			if (child_node.getValue().startsWith(token)) {
+			    // The closest node has been found, so return its path
+			    return new TreePath(child_node.getPath());
+			}
+		    }
+
+		    // Not even a partial match
+		    return null;
+		}
+	    }
+
+	    // If nothing else, return the path of the root node
+	    return new TreePath(tree_node.getPath());
+	}
+
+
+	public String getSelectedValue()
+	{
+	    return value.getText().replaceAll("\\\\", MetadataValueTreeNode.METADATA_VALUE_TREE_NODE_HIERARCHY_TOKEN);
+	}
+
+
+	public void rebuild(MetadataElement metadata_element, String metadata_value)
+	{
+	    // System.err.println("In MetadataValueTree.rebuild()...");
+
+	    // Clear selection
+	    if (metadata_element == null) {
+		if (metadata_edit_event == false) {
+		    System.err.println("Clearing selection...");
+		    selected_metadata_element = null;
+		    validateDisplay();
+		}
+		return;
+	    }
+
+	    // Reload the value tree model if the selected metadata element has changed
+	    if (selected_metadata_element != metadata_element) {
+		selected_metadata_element = metadata_element;
+		tree.setModel(selected_metadata_element.getMetadataValueTreeModel());
+	    }
+
+	    validateDisplay();
+
+	    setSelectedValue(metadata_value);
+	}
+
+
+	/** This function is copied from JTree::setPathToVisible(), and modified so tree rows
+	    are always shown flushed left. Note: doesn't do accessibleContext stuff. */
+	private void scrollTreePathToVisible(TreePath path)
+	{
+	    if (path != null) {
+		tree.makeVisible(path);
+
+		Rectangle bounds = tree.getPathBounds(path);
+		if (bounds != null) {
+		    bounds.width += bounds.x;
+		    bounds.x = 0;
+		    tree.scrollRectToVisible(bounds);
+		}
+	    }
+	}
+
+
+	/** Sets the value in the text field. */
+	private void setSelectedValue(String metadata_value)
+	{
+	    // Setting the text of the field causes the DocumentListener to be notified, and
+	    //   updating the tree is handled there (DocumentListenerImpl::validate())
+	    if (!card_showing.equals(NONE)) {
+		manual_text_edit_event = metadata_value.equals("");  // Set to false unless val == ""
+		value.setText(metadata_value);
+		manual_text_edit_event = true;
+	    }
+	}
+
+
+	private void validateDisplay()
+	{
+	    // If no metadata is selected in the metadata value table, display "no metadata element selected" card
+	    if (file_nodes == null || selected_metadata_element == null) {
+		metadata_value_tree_card_layout.show(control_pane, TREE_CARD_NO_METADATA_ELEMENT_SELECTED);
+	    }
+
+	    // Otherwise, display the card with the metadata value tree
+	    else {
+		metadata_value_tree_card_layout.show(control_pane, TREE_CARD);
+
+		// Special case the extracted metadata set
+		if (selected_metadata_element.getNamespace().equals(Utility.EXTRACTED_METADATA_NAMESPACE)) {
+		    // Display the panel showing the "you cannot edit this metadata" message
+		    String[] args = new String[1];
+		    args[0] = selected_metadata_element.getFullName();
+		    Dictionary.registerText(extracted_message, "MetaEdit.AutoMessage", args);
+		    card_layout.show(this, NONE);
+		    card_showing = NONE;
+		}
+		else {
+		    // Display the panel for viewing and assigning metadata
+		    card_layout.show(this, TREE);
+		    card_showing = TREE;
+		}
+
+		// Validate the buttons above the value tree
+		MetadataValueTableEntry metadata_value_table_entry = metadata_value_table.getSelectedMetadataValueTableEntry();
+		if (metadata_value_table_entry.getValue().equals("")) {
+		    // Can only append if something has been entered
+		    add.setEnabled((getSelectedValue().length() > 0));
+
+		    // Nothing to replace or remove
+		    update.setEnabled(false);
+		    remove.setEnabled(false);
 		    return;
 		}
 
-		repostEvent(e);
-		dispatchComponent = null;
-		setValueIsAdjusting(false);
-	    } else {
-		adjustFocusAndSelection(e);
-	    }
-        }
-
-
-        public void mouseEntered(MouseEvent e) {}
-
-        public void mouseExited(MouseEvent e) {}
-
-	//  The Table's mouse motion listener methods.
-
-        public void mouseMoved(MouseEvent e) {}
-
-        public void mouseDragged(MouseEvent e) {
-	    if (shouldIgnore(e)) {
-	        return;
-	    }
-
-            repostEvent(e);
-
-            CellEditor editor = table.getCellEditor();
-            if (editor == null || editor.shouldSelectCell(e)) {
-                Point p = e.getPoint();
-                int row = table.rowAtPoint(p);
-                int column = table.columnAtPoint(p);
-	        // The autoscroller can generate drag events outside the Table's range.
-                if ((column == -1) || (row == -1)) {
-                    return;
-                }
-	        table.changeSelection(row, column, false, true);
-            }
-        }
-    }
-
-
-    /** A listener for right mouse button clicks over the collection tree. */
-    private class RightButtonListener
-	extends MouseAdapter {
-	/** Called whenever a mouse click occurs (right or left) over a target component.
-	 * @param event A <strong>MouseEvent</strong> containing further information about the mouse click action.
-	 * @see org.greenstone.gatherer.gui.EnrichPane.RightButtonMenu
-	 */
-	public void mouseClicked(MouseEvent event) {
-	    if (SwingUtilities.isRightMouseButton(event)) {
-		new RightButtonMenu(event);
-	    }
-	}
-    }
-
-
-    /** When a user right-clicks within the collection tree they are presented with a small popup menu of context based options. This class provides such functionality.
-     */
-    private class RightButtonMenu
-	extends JPopupMenu
-	implements ActionListener {
-
-	/** The tree over which the right click action occurred. */
-	private DragTree tree = null;
-	/** The tree nodes selected when the right click action occurred. */
-	private TreePath[] selection_paths = null;
-	/** The file record over which the right click action occurred. */
-	private FileNode node = null;
-
-	private JMenuItem collapse_folder = null;
-	private JMenuItem expand_folder = null;
-	private JMenuItem metaaudit = null;
-	private JMenuItem open_externally = null;
-
-
-	private RightButtonMenu(MouseEvent event)
-	{
-	    super();
-	    this.tree = collection_tree;
-
-	    // Get the paths currently selected in the tree
-	    selection_paths = tree.getSelectionPaths();
-
-	    // Create an appropriate context menu, based on what is selected
-	    buildContextMenu(selection_paths);
-
-	    // Show the popup menu on screen
-	    show(tree, event.getX(), event.getY());
-	}
-
-
-	private void buildContextMenu(TreePath[] selection_paths)
-	{
-	    // If nothing is selected, no options are available
-	    if (selection_paths == null) {
-		return;
-	    }
-
-	    DebugStream.println("Number of files/folders selected: " + selection_paths.length);
-
-	    // Always have meta-audit option
-	    String[] args = new String[1];
-	    args[0] = collection_tree.getSelectionDetails();
-	    metaaudit = new JMenuItem(Dictionary.get("Menu.Metadata_View", args), KeyEvent.VK_A);
-	    metaaudit.addActionListener(this);
-	    add(metaaudit);
-
-	    // Only meta-audit is available if multiple items are selected...
-	    if (selection_paths.length > 1) {
-		return;
-	    }
-
-	    TreePath path = selection_paths[0];
-	    node = (FileNode) path.getLastPathComponent();
-
-	    // ---- Options for file nodes ----
-	    if (node.isLeaf()) {
-		// Open the file in an external program
-		open_externally = new JMenuItem(Dictionary.get("Menu.Open_Externally"), KeyEvent.VK_O);
-		open_externally.addActionListener(this);
-		add(open_externally);
-
-		return;
-	    }
-
-	    // ---- Options for folder nodes ----
-	    // Collapse or expand, depending on current status
-	    if (tree.isExpanded(path)) {
-		collapse_folder = new JMenuItem(Dictionary.get("Menu.Collapse"), KeyEvent.VK_C);
-		collapse_folder.addActionListener(this);
-		add(collapse_folder);
-	    }
-	    else {
-		expand_folder = new JMenuItem(Dictionary.get("Menu.Expand"), KeyEvent.VK_O);
-		expand_folder.addActionListener(this);
-		add(expand_folder);
-	    }
-	}
-
-
-	/** Called whenever one of the menu items is clicked, this method then causes the appropriate effect. */
-	public void actionPerformed(ActionEvent event)
-	{
-	    Object source = event.getSource();
-
-	    // Collapse folder
-	    if (source == collapse_folder) {
-		tree.collapsePath(selection_paths[0]);
-	    }
-
-	    // Expand folder
-	    else if (source == expand_folder) {
-		tree.expandPath(selection_paths[0]);
-	    }
-
-	    // Meta-audit
-	    else if (source == metaaudit) {
- 		Gatherer.g_man.showMetaAuditBox();
- 	    }
-
-	    // Open in external program
-	    else if (source == open_externally) {
-		Gatherer.self.spawnApplication(node.getFile());
+		// Check if the text in the value field is the same as the metadata value
+		if (getSelectedValue().equals(metadata_value_table_entry.getFullValue())) {
+		    // Can't replace
+		    update.setEnabled(false);
+
+		    // Adding, however, is dependant on whether the selected metadata is common or uncommon. If the later then you can append so as to make it common.
+		    add.setEnabled(!metadata_value_table.isSelectedMetadataValueTableEntryCommon());
+		}
+		else {
+		    // Can append or replace, if something has been entered
+		    add.setEnabled((getSelectedValue().length() > 0));
+		    update.setEnabled((getSelectedValue().length() > 0));
+		}
+
+		// Can only remove if the metadata is file level
+		if (metadata_value_table_entry != null) {  // Shouldn't be necessary, but is
+		    remove.setEnabled((metadata_value_table_entry.isInheritedMetadata() == false));
+		}
+	    }
+	}
+
+
+	/** Handles TreeSelectionEvents. */
+	public void valueChanged(TreeSelectionEvent event)
+	{
+	    if (tree.getSelectionCount() != 0 && !ignore_tree_selection_event) {
+		TreePath path = tree.getSelectionPath();
+		MetadataValueTreeNode node = (MetadataValueTreeNode) path.getLastPathComponent();
+		setSelectedValue(node.getFullValue());
+	    }
+	}
+
+
+	private class MetadataFieldListener
+	    implements KeyListener {
+
+	    /** Gives notification of key events on the text field */
+	    public void keyPressed(KeyEvent e) {
+		if (e.getKeyCode() == KeyEvent.VK_TAB) {
+		    // Tab: Auto-complete
+		    if (tree.getSelectionCount() != 0 && !getSelectedValue().equals("")) {
+			TreePath path = tree.getSelectionPath();
+			MetadataValueTreeNode node = (MetadataValueTreeNode) path.getLastPathComponent();
+			setSelectedValue(node.getFullValue());
+		    }
+		}
+		if (e.getKeyCode() == KeyEvent.VK_ENTER) {
+		    // Enter: Append the metadata value, if we're allowed to
+		    if (add.isEnabled()) {
+			add.doClick();
+		    }
+		}
+	    }
+
+	    public void keyReleased(KeyEvent e) { }
+
+	    public void keyTyped(KeyEvent e) { }
+	}
+
+
+	private class DocumentListenerImpl
+	    implements DocumentListener
+	{
+	    /** Gives notification that an attribute or set of attributes changed */
+	    public void changedUpdate(DocumentEvent e) {
+		validate();
+	    }
+
+	    /** Gives notification that there was an insert into the document */
+	    public void insertUpdate(DocumentEvent e) {
+		validate();
+	    }
+
+	    /** Gives notification that a portion of the document has been removed */
+	    public void removeUpdate(DocumentEvent e) {
+		validate();
+	    }
+
+
+	    /** Ensures that the value text field and value tree are synchronized */
+	    private void validate()
+	    {
+		String value_text = getSelectedValue();
+
+		// Ignore the validate() with empty text that occurs when value.setText() is used
+		if (!value_text.equals("") || manual_text_edit_event == true) {
+		    TreePath closest_path = getClosestPath(value_text);
+
+		    // Select the new path in the tree
+		    // The tree selection event this causes must be ignored, since it alters value
+		    ignore_tree_selection_event = true;
+		    tree.setSelectionPath(closest_path);
+		    ignore_tree_selection_event = false;
+
+		    // If a folder has been specified, make sure it is expanded
+		    if (value_text.endsWith(MetadataValueTreeNode.METADATA_VALUE_TREE_NODE_HIERARCHY_TOKEN) && !tree.isExpanded(closest_path)) {
+			tree.expandPath(closest_path);
+		    }
+
+		    // Make sure the path is visible on the screen
+		    scrollTreePathToVisible(closest_path);
+		    // One call should be enough, but it isn't in some cases (for some reason)
+		    scrollTreePathToVisible(closest_path);
+
+		    // Update the status of the buttons
+		    validateDisplay();
+		}
 	    }
 	}
